<!-- Example widget for demonstration  -->
<script lang="ts">
	import { onDestroy, onMount } from 'svelte';
	import { streamerApi } from '$lib/requests/requests';
	import { page } from '$app/stores';
	import type { Streamer } from '$lib/api';
	import { ws } from '$lib/config';
	import { teams, type Team } from '$lib/teams';
	import type { Donor } from '$lib/donors';
	import { quintOut } from 'svelte/easing';
	import { slide } from 'svelte/transition';
	import Counter from '../Counter..svelte';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	// One might use this widget with a GET param for the streamer ID
	// ?streamer=1

	// This URI should work : http://localhost:5173/tops-ekip?team=1

	const teamId = $page.url.searchParams.get('team');
	const team: Team | null = teamId ? teams[+teamId] : null;

	let tops: Donor[];
	let last: Donor;
	let selected: string = 'top';
	let selectedInterval: number;

	function select() {
		if (selected === 'top') {
			selected = 'last';
		} else if (selected === 'last') {
			selected = 'top';
		}
	}

	onMount(async () => {
		selectedInterval = setInterval(() => select(), 20000);

		// Start WS
		const socket = new ReconnectingWebSocket(ws());

		socket.addEventListener('open', function (event) {
			socket.send(JSON.stringify({ op: 'sub', msg: `tops.teams.${teamId}` }));
			socket.send(JSON.stringify({ op: 'sub', msg: `teams.${teamId}.don` }));
		});

		socket.addEventListener('message', function (event) {
			let data = JSON.parse(event.data);

			// updatePot(data.d.pot / 100);
			console.log('Received update', data);

			switch (data.r) {
				case `tops.teams.${teamId}`:
					tops = data.d.dons;
					break;
				case `teams.${teamId}.don`:
					last = !last || data.d.don.time > last.time ? data.d.don : last;
					break;
				case `refresh`:
					// Refresh the page
					setTimeout(() => {
						window.location.reload();
					}, Math.random() * 1000);
					break;
			}
		});
	});
	onDestroy(() => {
		clearInterval(selectedInterval);
	});
</script>

{#if tops && last}
	<div class="flex flex-col justify-center items-center gap-1">
		<h1 class="text-2xl text-white flex flex-col items-center">
			{#if selected === 'top'}
				<div
					class="team-title fredoka-bold flex gap-1"
					in:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
					out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
				>
					Top Donateur <p style:color={team?.color}>
						{team?.name}
					</p>
					:
				</div>
			{:else if selected === 'last'}
				<div
					class="team-title fredoka-bold flex gap-1"
					in:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
					out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
				>
					Dernier Donateur <p
						class={teamId === '3' ? 'team-dark' : 'team-light'}
						style:color={team?.color}
					>
						{team?.name}
					</p>
					:
				</div>
			{/if}
		</h1>
		<div class="background-frame flex flex-row justify-center">
			{#if selected === 'top'}
				<div
					class="top-donateur text-item text-3xl"
					in:slide={{ delay: 550, duration: 300, easing: quintOut, axis: 'x' }}
					out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'x' }}
				>
					<div class="donateur fredoka">
						{(tops[0]?.first_name || 'John') + ' ' + (tops[0]?.last_name || 'Doe')}
					</div>
					<div class="top-amount flex red-hat">
						<p class=" fredoka">-</p>
						<Counter amount={tops[0]?.amount} />
						<p class=" fredoka">€</p>
					</div>
				</div>
			{:else if selected === 'last'}
				<p
					class="donateur text-item text-3xl fredoka"
					in:slide={{ delay: 550, duration: 300, easing: quintOut, axis: 'x' }}
					out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'x' }}
				>
					{last.first_name + ' ' + last.last_name}
				</p>
			{/if}
		</div>
	</div>
{/if}

<style lang="scss">
	@import url('https://fonts.googleapis.com/css2?family=Red+Hat+Mono:wght@700&display=swap');
	@import url('https://fonts.googleapis.com/css2?family=Fredoka:wght@300..700&display=swap');
	.red-hat {
		font-family: 'Red Hat Mono', monospace;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
	}
	.fredoka {
		font-family: 'Fredoka', sans-serif;
		font-optical-sizing: auto;
		font-weight: 500;
		font-style: normal;
		font-variation-settings: 'wdth' 100;
	}
	.fredoka-bold {
		font-family: 'Fredoka', sans-serif;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
		font-variation-settings: 'wdth' 100;
		margin: 0 1rem;
	}
	.top-donateur {
		display: flex;
		gap: 5px;
		.donateur {
			flex: 0 1 auto;
			text-overflow: ellipsis;
			white-space: nowrap;
			word-break: break-all;
			overflow: hidden;
		}
		.top-amount {
			flex: 1 0 100px;
			gap: 5px;
		}
	}
	.text-item {
		text-overflow: ellipsis;
		white-space: nowrap;
		word-break: break-all;
		overflow: hidden;
		max-width: 358px;
		margin: 0 2px 0 0;
	}
	.background-frame {
		padding: 4px 16px;
		min-width: 250px;
		word-break: break-all;
		position: relative;
		box-sizing: border-box;
		$border: 5px;
		color: #fff;
		background: #444;
		background-clip: padding-box; /* !importanté */
		border: solid $border transparent; /* !importanté */
		border-radius: 30px;

		&:before {
			content: '';
			position: absolute;
			top: 0;
			right: 0;
			bottom: 0;
			left: 0;
			z-index: -1;
			margin: -$border; /* !importanté */
			border-radius: inherit; /* !importanté */
			background: linear-gradient(to right, red, orange);
		}
	}
	.team-title {
		background: #444;
		padding: 0 10px;
		border-radius: 30px;
	}
</style>
